<template>
    <div :class="{'btn-group btn-group-sm float-end': isButtonGroup }"
         role="group" aria-label="Notification actions">

        <button v-if="isRead"
                class="btn"
                :class="overrideClass"
                type="button"
                :title="$t('markAsUnread')"
                @click="markAsUnread"
                >
            <i class="fa fa-sm fa-envelope-o"></i>
            <span v-if="!buttonNoText" class="ps-2">
                {{ $t('markAsUnread') }}
            </span>
        </button>

        <button v-if="!isRead"
                class="btn"
                :class="overrideClass"
                type="button"
                :title="$t('markAsRead')"
                @click="markAsRead"
                >
            <i class="fa fa-sm fa-envelope-open-o"></i>
            <span v-if="!buttonNoText" class="ps-2">
                {{ $t('markAsRead') }}
            </span>
        </button>

        <a v-if="isButtonGroup"
            type="button"
            class="btn btn-outline-primary"
            :href="showUrl"
            :title="$t('action.show')"
            >
            <i class="fa fa-sm fa-comment-o"></i>
        </a>

    </div>
</template>

<script>
import { makeFetch } from 'ChillMainAssets/lib/api/apiMethods.ts';

export default {
    name: "NotificationReadToggle",
    props: {
        isRead: {
            required: true,
            type: Boolean,
        },
        notificationId: {
            required: true,
            type: Number,
        },
        // Optional
        buttonClass: {
            required: false,
            type: String
        },
        buttonNoText: {
            required: false,
            type: Boolean,
        },
        showUrl: {
            required: false,
            type: String
        }
    },
    emits: ['markRead', 'markUnread'],
    computed: {
        /// [Option] override default button appearance (btn-misc)
        overrideClass() {
            return this.buttonClass ? this.buttonClass : 'btn-misc'
        },
        /// [Option] don't display text on button
        buttonHideText() {
            return this.buttonNoText;
        },
        /// [Option] showUrl is href for show page second button.
        //  When passed, the component return a button-group with 2 buttons.
        isButtonGroup() {
            return this.showUrl;
        }
    },
    methods: {
        markAsUnread() {
           makeFetch('POST', `/api/1.0/main/notification/${this.notificationId}/mark/unread`, []).then(response => {
               this.$emit('markRead', { notificationId: this.notificationId });
           })
        },
        markAsRead() {
            makeFetch('POST', `/api/1.0/main/notification/${this.notificationId}/mark/read`, []).then(response => {
                this.$emit('markUnread', { notificationId: this.notificationId });
            })
        },
    },
    i18n: {
        messages: {
            fr: {
                markAsUnread: 'Marquer comme non-lu',
                markAsRead: 'Marquer comme lu'
            }
        }
    }
}
</script>

<style lang="scss">

</style>
